Index: docs/howto/deployment/modpython.txt
===================================================================
--- docs/howto/deployment/modpython.txt	(revision 13861)
+++ docs/howto/deployment/modpython.txt	(working copy)
@@ -1,5 +1,3 @@
-.. _howto-deployment-modpython:
-
 ============================================
 How to use Django with Apache and mod_python
 ============================================
Index: docs/topics/http/urls.txt
===================================================================
--- docs/topics/http/urls.txt	(revision 13861)
+++ docs/topics/http/urls.txt	(working copy)
@@ -939,9 +939,9 @@
 However, if your application constructs part of the URL hierarchy itself, you
 may occasionally need to generate URLs. In that case, you need to be able to
 find the base URL of the Django project within its web server
-(normally, :func:`~django.core.urlresolvers.reverse` takes care of this for 
+(normally, :func:`~django.core.urlresolvers.reverse` takes care of this for
 you). In that case, you can call ``get_script_prefix()``, which will return the
 script prefix portion of the URL for your Django project. If your Django
 project is at the root of its webserver, this is always ``"/"``, but it can be
-changed, for instance  by using ``django.root`` (see :ref:`How to use
-Django with Apache and mod_python <howto-deployment-modpython>`).
+changed, for instance  by using ``django.root`` (see :doc:`How to use
+Django with Apache and mod_python </howto/deployment/modpython>`).
Index: docs/topics/templates.txt
===================================================================
--- docs/topics/templates.txt	(revision 13861)
+++ docs/topics/templates.txt	(working copy)
@@ -590,7 +590,7 @@
         {{ comment }}
     {% endfor %}
 
-Similarly, :doc:`QuerySets<ref/models/querysets>` provide a ``count()`` method
+Similarly, :doc:`QuerySets</ref/models/querysets>` provide a ``count()`` method
 to count the number of objects they contain. Therefore, you can obtain a count
 of all comments related to the current task with::
 
Index: docs/topics/signals.txt
===================================================================
--- docs/topics/signals.txt	(revision 13861)
+++ docs/topics/signals.txt	(working copy)
@@ -89,7 +89,8 @@
 
     request_finished.connect(my_callback)
 
-Alternatively, you can use a decorator used when you define your receiver:
+Alternatively, you can use a ``receiver`` decorator when you define your
+receiver:
 
 .. code-block:: python
 
@@ -102,6 +103,10 @@
 
 Now, our ``my_callback`` function will be called each time a request finishes.
 
+.. versionadded:: 1.3
+
+The ``receiver`` decorator was added in Django 1.3.
+
 .. admonition:: Where should this code live?
 
     You can put signal handling and registration code anywhere you like.
Index: docs/ref/generic-views.txt
===================================================================
--- docs/ref/generic-views.txt	(revision 13861)
+++ docs/ref/generic-views.txt	(working copy)
@@ -96,6 +96,8 @@
 .. versionadded:: 1.1
     The ``permanent`` keyword argument is new in Django 1.1.
 
+.. versionadded:: 1.3
+    The ``query_string`` keyword argument is new in Django 1.3.
 
 **Example:**
 
@@ -380,7 +382,7 @@
 
     * ``date_list``: A list of ``datetime.date`` objects representing all
       days that have objects available in the given month, according to
-      ``queryset``, in ascending order.    
+      ``queryset``, in ascending order.
 
     * ``month``: A ``datetime.date`` object representing the given month.
 
Index: docs/ref/request-response.txt
===================================================================
--- docs/ref/request-response.txt	(revision 13861)
+++ docs/ref/request-response.txt	(working copy)
@@ -46,7 +46,7 @@
     attr:`~HttpRequest.path` can make your code much easier to move between test
     and deployment servers.
 
-    For example, if the ``django.root`` for your application is set to 
+    For example, if the ``django.root`` for your application is set to
     ``"/minfo"``, then ``path`` might be ``"/minfo/music/bands/the_beatles/"``
     and ``path_info`` would be ``"/music/bands/the_beatles/"``.
 
@@ -542,6 +542,12 @@
 
     .. _`cookie Morsel`: http://docs.python.org/library/cookie.html#Cookie.Morsel
 
+    .. versionchanged:: 1.3
+
+    Both the possibility of specifying a ``datetime.datetime`` object in
+    ``expires`` and the auto-calculation of ``max_age`` in such case were added
+    in Django 1.3.
+
 .. method:: HttpResponse.delete_cookie(key, path='/', domain=None)
 
     Deletes the cookie with the given key. Fails silently if the key doesn't