diff --git a/django/contrib/markup/templatetags/markup.py b/django/contrib/markup/templatetags/markup.py
index 912655f..7cdc04c 100644
--- a/django/contrib/markup/templatetags/markup.py
+++ b/django/contrib/markup/templatetags/markup.py
@@ -8,7 +8,7 @@ markup syntaxes to HTML; currently there is support for:
     * Markdown, which requires the Python-markdown library from
       http://www.freewisdom.org/projects/python-markdown
 
-    * ReStructuredText, which requires docutils from http://docutils.sf.net/
+    * reStructuredText, which requires docutils from http://docutils.sf.net/
 """
 
 from django import template
diff --git a/docs/faq/general.txt b/docs/faq/general.txt
index 1fc0f18..96abad2 100644
--- a/docs/faq/general.txt
+++ b/docs/faq/general.txt
@@ -167,14 +167,14 @@ How can I download the Django documentation to read it offline?
 ---------------------------------------------------------------
 
 The Django docs are available in the ``docs`` directory of each Django tarball
-release. These docs are in ReST (ReStructured Text) format, and each text file
+release. These docs are in reST (reStructuredText) format, and each text file
 corresponds to a Web page on the official Django site.
 
 Because the documentation is `stored in revision control`_, you can browse
 documentation changes just like you can browse code changes.
 
 Technically, the docs on Django's site are generated from the latest development
-versions of those ReST documents, so the docs on the Django site may offer more
+versions of those reST documents, so the docs on the Django site may offer more
 information than the docs that come with the latest Django release.
 
 .. _stored in revision control: http://code.djangoproject.com/browser/django/trunk/docs
diff --git a/docs/internals/contributing.txt b/docs/internals/contributing.txt
index 6bf8aa1..6310562 100644
--- a/docs/internals/contributing.txt
+++ b/docs/internals/contributing.txt
@@ -700,10 +700,10 @@ There's a full page of information about the :doc:`Django documentation
 system </internals/documentation>` that you should read prior to working on the
 documentation.
 
-Guidelines for ReST files
+Guidelines for reST files
 -------------------------
 
-These guidelines regulate the format of our ReST documentation:
+These guidelines regulate the format of our reST documentation:
 
     * In section titles, capitalize only initial words and proper nouns.
 
diff --git a/docs/internals/documentation.txt b/docs/internals/documentation.txt
index 63f248d..5185ec7 100644
--- a/docs/internals/documentation.txt
+++ b/docs/internals/documentation.txt
@@ -20,7 +20,7 @@ Sphinx -- ``easy_install Sphinx`` should do the trick.
 
 Then, building the html is easy; just ``make html`` from the ``docs`` directory.
 
-To get started contributing, you'll want to read the `ReStructuredText
+To get started contributing, you'll want to read the `reStructuredText
 Primer`__. After that, you'll want to read about the `Sphinx-specific markup`__
 that's used to manage metadata, indexing, and cross-references.
 
diff --git a/docs/ref/contrib/markup.txt b/docs/ref/contrib/markup.txt
index f2c43fe..9282313 100644
--- a/docs/ref/contrib/markup.txt
+++ b/docs/ref/contrib/markup.txt
@@ -10,7 +10,7 @@ languages:
 
     * ``textile`` -- implements `Textile`_ -- requires `PyTextile`_
     * ``markdown`` -- implements `Markdown`_ -- requires `Python-markdown`_
-    * ``restructuredtext`` -- implements `ReST (ReStructured Text)`_
+    * ``restructuredtext`` -- implements `reST (reStructured Text)`_
       -- requires `doc-utils`_
 
 In each case, the filter expects formatted markup as a string and
@@ -26,12 +26,12 @@ For more documentation, read the source code in
 
 .. _Textile: http://en.wikipedia.org/wiki/Textile_%28markup_language%29
 .. _Markdown: http://en.wikipedia.org/wiki/Markdown
-.. _ReST (ReStructured Text): http://en.wikipedia.org/wiki/ReStructuredText
+.. _reST (reStructured Text): http://en.wikipedia.org/wiki/ReStructuredText
 .. _PyTextile: http://loopcore.com/python-textile/
 .. _Python-markdown: http://www.freewisdom.org/projects/python-markdown
 .. _doc-utils: http://docutils.sf.net/
 
-ReStructured Text
+reStructured Text
 -----------------
 
 When using the ``restructuredtext`` markup filter you can define a
diff --git a/docs/ref/templates/builtins.txt b/docs/ref/templates/builtins.txt
index a20ab17..d5afd8d 100644
--- a/docs/ref/templates/builtins.txt
+++ b/docs/ref/templates/builtins.txt
@@ -2092,7 +2092,7 @@ A collection of template filters that implement these common markup languages:
 
     * Textile
     * Markdown
-    * ReST (ReStructured Text)
+    * reST (reStructuredText)
 
 See the :doc:`markup documentation </ref/contrib/markup>`.
 